Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_CORE_COMPONENTS.gise
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_CORE_COMPONENTS.gise	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_CORE_COMPONENTS.gise	(revision 39)
@@ -29,9 +29,226 @@
     <file xil_pn:fileType="FILE_SYMBOL" xil_pn:name="MPI_NOC.sym" xil_pn:origination="imported"/>
     <file xil_pn:fileType="FILE_NCD" xil_pn:name="MPI_NOC_guide.ncd" xil_pn:origination="imported"/>
+    <file xil_pn:fileType="FILE_CMD_LOG" xil_pn:name="MultiMPITest.cmd_log"/>
+    <file xil_pn:branch="Implementation" xil_pn:fileType="FILE_LSO" xil_pn:name="MultiMPITest.lso"/>
+    <file xil_pn:branch="Implementation" xil_pn:fileType="FILE_XST_PROJECT" xil_pn:name="MultiMPITest.prj"/>
+    <file xil_pn:branch="Implementation" xil_pn:fileType="FILE_XST_REPORT" xil_pn:name="MultiMPITest.syr"/>
+    <file xil_pn:branch="Implementation" xil_pn:fileType="FILE_XST" xil_pn:name="MultiMPITest.xst"/>
+    <file xil_pn:fileType="FILE_XST_PROJECT" xil_pn:name="MultiMPITest_beh.prj"/>
     <file xil_pn:fileType="FILE_NCD" xil_pn:name="MultiMPITest_guide.ncd" xil_pn:origination="imported"/>
+    <file xil_pn:branch="BehavioralSim" xil_pn:fileType="FILE_ISIM_EXE" xil_pn:name="MultiMPITest_isim_beh.exe"/>
+    <file xil_pn:fileType="FILE_ISIM_MISC" xil_pn:name="MultiMPITest_isim_beh.wdb"/>
+    <file xil_pn:branch="Implementation" xil_pn:fileType="FILE_XST_PROJECT" xil_pn:name="MultiMPITest_stx_beh.prj"/>
+    <file xil_pn:fileType="FILE_HTML" xil_pn:name="MultiMPITest_summary.html"/>
+    <file xil_pn:fileType="FILE_XRPT" xil_pn:name="MultiMPITest_xst.xrpt"/>
     <file xil_pn:fileType="FILE_NCD" xil_pn:name="SWITCH_GEN_guide.ncd" xil_pn:origination="imported"/>
+    <file xil_pn:fileType="FILE_XMSGS" xil_pn:name="_xmsgs/xst.xmsgs"/>
+    <file xil_pn:fileType="FILE_LOG" xil_pn:name="fuse.log"/>
+    <file xil_pn:fileType="FILE_DIRECTORY" xil_pn:name="isim"/>
+    <file xil_pn:branch="BehavioralSim" xil_pn:fileType="FILE_CMD" xil_pn:name="isim.cmd"/>
+    <file xil_pn:branch="BehavioralSim" xil_pn:fileType="FILE_LOG" xil_pn:name="isim.log"/>
+    <file xil_pn:fileType="FILE_FITTER_REPORT" xil_pn:name="webtalk_pn.xml"/>
+    <file xil_pn:branch="BehavioralSim" xil_pn:fileType="FILE_INI" xil_pn:name="xilinxsim.ini"/>
+    <file xil_pn:fileType="FILE_DIRECTORY" xil_pn:name="xst"/>
   </files>
 
-  <transforms xmlns="http://www.xilinx.com/XMLSchema"/>
+  <transforms xmlns="http://www.xilinx.com/XMLSchema">
+    <transform xil_pn:end_ts="1354677003" xil_pn:name="TRAN_copyInitialToAbstractSimulation" xil_pn:start_ts="1354677003">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354875772" xil_pn:in_ck="-6104420166436042342" xil_pn:name="TRAN_copyAbstractToPostAbstractSimulation" xil_pn:start_ts="1354875772">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Arbiter.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/CoreTypes.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Crossbar.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Crossbit.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/FIFO_256_FWFT.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/INPUT_PORT_MODULE.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/OUTPUT_PORT_MODULE.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Proto_receiv.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/RAM_256.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER12_12.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER13_13.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER14_14.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER15_15.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER16_16.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER2_2.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER3_3.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER4_4.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER5_5.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER6_6.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER7_7.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER8_8.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SWITCH_GEN.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Scheduler.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/proto_send.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/stimuli1.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/test_xbar_8x8.vhd"/>
+      <outfile xil_pn:name="CORE_MPI.vhd"/>
+      <outfile xil_pn:name="DEMUX1.vhd"/>
+      <outfile xil_pn:name="DMA_ARBITER.vhd"/>
+      <outfile xil_pn:name="EX1_FSM.vhd"/>
+      <outfile xil_pn:name="EX2_FSM.vhd"/>
+      <outfile xil_pn:name="EX3_FSM.vhd"/>
+      <outfile xil_pn:name="EX4_FSM.vhd"/>
+      <outfile xil_pn:name="Ex0_Fsm.vhd"/>
+      <outfile xil_pn:name="FIFO_64_FWFT.vhd"/>
+      <outfile xil_pn:name="FIfo_mem.vhd"/>
+      <outfile xil_pn:name="FIfo_proc.vhd"/>
+      <outfile xil_pn:name="MPICORETEST.vhd"/>
+      <outfile xil_pn:name="MPI_CORE_SCHEDULER.vhd"/>
+      <outfile xil_pn:name="MPI_NOC.vhd"/>
+      <outfile xil_pn:name="MPI_PKG.vhd"/>
+      <outfile xil_pn:name="MPI_RMA.vhd"/>
+      <outfile xil_pn:name="MUX1.vhd"/>
+      <outfile xil_pn:name="MUX8.vhd"/>
+      <outfile xil_pn:name="MultiMPITest.vhd"/>
+      <outfile xil_pn:name="PE.vhd"/>
+      <outfile xil_pn:name="Packet_type.vhd"/>
+      <outfile xil_pn:name="RAM_32_32.vhd"/>
+      <outfile xil_pn:name="RAM_64.vhd"/>
+      <outfile xil_pn:name="image_pkg.vhd"/>
+      <outfile xil_pn:name="load_instr.vhd"/>
+      <outfile xil_pn:name="round_robbin_machine.vhd"/>
+      <outfile xil_pn:name="sim_fifo.vhd"/>
+    </transform>
+    <transform xil_pn:end_ts="1354793902" xil_pn:name="TRAN_xawsToSimhdl" xil_pn:prop_ck="-8804766714685316537" xil_pn:start_ts="1354793902">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354793902" xil_pn:name="TRAN_schematicsToHdlSim" xil_pn:prop_ck="225563001328936133" xil_pn:start_ts="1354793902">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354677003" xil_pn:name="TRAN_regenerateCoresSim" xil_pn:prop_ck="8414388184515446556" xil_pn:start_ts="1354677003">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354875772" xil_pn:in_ck="-6104420166436042342" xil_pn:name="TRAN_copyPostAbstractToPreSimulation" xil_pn:start_ts="1354875772">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Arbiter.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/CoreTypes.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Crossbar.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Crossbit.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/FIFO_256_FWFT.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/INPUT_PORT_MODULE.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/OUTPUT_PORT_MODULE.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Proto_receiv.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/RAM_256.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER12_12.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER13_13.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER14_14.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER15_15.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER16_16.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER2_2.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER3_3.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER4_4.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER5_5.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER6_6.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER7_7.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SCHEDULER8_8.VHD"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/SWITCH_GEN.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/Scheduler.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/proto_send.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/stimuli1.vhd"/>
+      <outfile xil_pn:name="../SWITCH_GENERIC_16_16/test_xbar_8x8.vhd"/>
+      <outfile xil_pn:name="CORE_MPI.vhd"/>
+      <outfile xil_pn:name="DEMUX1.vhd"/>
+      <outfile xil_pn:name="DMA_ARBITER.vhd"/>
+      <outfile xil_pn:name="EX1_FSM.vhd"/>
+      <outfile xil_pn:name="EX2_FSM.vhd"/>
+      <outfile xil_pn:name="EX3_FSM.vhd"/>
+      <outfile xil_pn:name="EX4_FSM.vhd"/>
+      <outfile xil_pn:name="Ex0_Fsm.vhd"/>
+      <outfile xil_pn:name="FIFO_64_FWFT.vhd"/>
+      <outfile xil_pn:name="FIfo_mem.vhd"/>
+      <outfile xil_pn:name="FIfo_proc.vhd"/>
+      <outfile xil_pn:name="MPICORETEST.vhd"/>
+      <outfile xil_pn:name="MPI_CORE_SCHEDULER.vhd"/>
+      <outfile xil_pn:name="MPI_NOC.vhd"/>
+      <outfile xil_pn:name="MPI_PKG.vhd"/>
+      <outfile xil_pn:name="MPI_RMA.vhd"/>
+      <outfile xil_pn:name="MUX1.vhd"/>
+      <outfile xil_pn:name="MUX8.vhd"/>
+      <outfile xil_pn:name="MultiMPITest.vhd"/>
+      <outfile xil_pn:name="PE.vhd"/>
+      <outfile xil_pn:name="Packet_type.vhd"/>
+      <outfile xil_pn:name="RAM_32_32.vhd"/>
+      <outfile xil_pn:name="RAM_64.vhd"/>
+      <outfile xil_pn:name="image_pkg.vhd"/>
+      <outfile xil_pn:name="load_instr.vhd"/>
+      <outfile xil_pn:name="round_robbin_machine.vhd"/>
+      <outfile xil_pn:name="sim_fifo.vhd"/>
+    </transform>
+    <transform xil_pn:end_ts="1354875803" xil_pn:in_ck="-6104420166436042342" xil_pn:name="TRAN_ISimulateBehavioralModelRunFuse" xil_pn:prop_ck="-69836859381131890" xil_pn:start_ts="1354875772">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+      <outfile xil_pn:name="MultiMPITest_beh.prj"/>
+      <outfile xil_pn:name="MultiMPITest_isim_beh.exe"/>
+      <outfile xil_pn:name="fuse.log"/>
+      <outfile xil_pn:name="isim"/>
+      <outfile xil_pn:name="isim.log"/>
+      <outfile xil_pn:name="xilinxsim.ini"/>
+    </transform>
+    <transform xil_pn:end_ts="1354875805" xil_pn:in_ck="2770422429889795360" xil_pn:name="TRAN_ISimulateBehavioralModel" xil_pn:prop_ck="4736240422826914561" xil_pn:start_ts="1354875803">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+      <outfile xil_pn:name="MultiMPITest_isim_beh.wdb"/>
+      <outfile xil_pn:name="isim.cmd"/>
+      <outfile xil_pn:name="isim.log"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_copyInitialToXSTAbstractSynthesis" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_schematicsToHdl" xil_pn:prop_ck="-1582102620978348987" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_regenerateCores" xil_pn:prop_ck="8414388184515446556" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_SubProjectAbstractToPreProxy" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_xawsTohdl" xil_pn:prop_ck="-8804766714685316537" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_SubProjectPreToStructuralProxy" xil_pn:prop_ck="7424531393529279708" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714616" xil_pn:name="TRAN_platgen" xil_pn:prop_ck="2970117682751773030" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714645" xil_pn:in_ck="8953937964106919530" xil_pn:name="TRANEXT_xstsynthesize_spartan6" xil_pn:prop_ck="5642850437041008532" xil_pn:start_ts="1354714616">
+      <status xil_pn:value="FailedRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+      <status xil_pn:value="OutOfDateForInputs"/>
+      <status xil_pn:value="OutOfDateForOutputs"/>
+      <status xil_pn:value="InputChanged"/>
+      <status xil_pn:value="OutputChanged"/>
+      <status xil_pn:value="OutputRemoved"/>
+      <outfile xil_pn:name="MultiMPITest.lso"/>
+      <outfile xil_pn:name="MultiMPITest.prj"/>
+      <outfile xil_pn:name="MultiMPITest.syr"/>
+      <outfile xil_pn:name="MultiMPITest.xst"/>
+      <outfile xil_pn:name="MultiMPITest_stx_beh.prj"/>
+      <outfile xil_pn:name="MultiMPITest_xst.xrpt"/>
+      <outfile xil_pn:name="_xmsgs/xst.xmsgs"/>
+      <outfile xil_pn:name="webtalk_pn.xml"/>
+      <outfile xil_pn:name="xst"/>
+    </transform>
+    <transform xil_pn:end_ts="1354714645" xil_pn:in_ck="5944890944412384878" xil_pn:name="TRAN_compileBCD2" xil_pn:prop_ck="-4542759591300251492" xil_pn:start_ts="1354714645">
+      <status xil_pn:value="SuccessfullyRun"/>
+      <status xil_pn:value="ReadyToRun"/>
+    </transform>
+  </transforms>
 
 </generated_project>
Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_CORE_COMPONENTS.xise
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_CORE_COMPONENTS.xise	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_CORE_COMPONENTS.xise	(revision 39)
@@ -279,4 +279,8 @@
       <association xil_pn:name="Implementation"/>
       <library xil_pn:name="NocLib"/>
+    </file>
+    <file xil_pn:name="image_pkg.vhd" xil_pn:type="FILE_VHDL">
+      <association xil_pn:name="BehavioralSimulation"/>
+      <association xil_pn:name="Implementation"/>
     </file>
   </files>
Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_RMA.vhd
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_RMA.vhd	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MPI_RMA.vhd	(revision 39)
@@ -31,4 +31,5 @@
 									base :std_logic_vector; size : Mpi_Aint;disp_unit:natural; 
 									info:natural; comm:Mpi_Comm; Win: inout MPI_Win );
+procedure pMPI_Win_wait( NextCtx : inout natural;signal Interf:inout Core_io;signal SysRam :inout typ_dpram; Win :MPI_Win);
 -- declare functions and procedure	 
  procedure ReadMem(NextCtx : inout natural;signal Interf:inout Core_io;signal SysRam :inout typ_dpram;
@@ -85,4 +86,5 @@
 							
 							elsif dcount=4 then
+							if interf.ramsel='0' then
 								SysRam.we<='1';
 								SysRam.ena<='1';
@@ -92,33 +94,46 @@
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
 								dcount:=dcount+1;
+							end if;
 							elsif dcount=5 then 
+								if interf.ramsel='0' then
 								adresse:=core_put_adr+1;
 								sysRam.Data_in<=std_logic_vector(to_unsigned(Orig_Count,8)) ;--la longueur
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
 								dcount:=dcount+1;
+								end if;
 							elsif dcount=6 then
+								if interf.ramsel='0' then
 								adresse:=core_put_adr+2;
 								sysRam.Data_in<= Addr1(ADRLEN-1 downto Word) ; --source Haut
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
 								dcount:=dcount+1;
+								end if;
 							elsif dcount=7 then
+								if interf.ramsel='0' then
 								adresse:=core_put_adr+3;
 								sysRam.Data_in<=Addr1(Word-1 downto 0);  --source Bas
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
 								dcount:=dcount+1;
+								end if;
 							elsif dcount=8 then
+								if interf.ramsel='0' then
 								adresse:=core_put_adr+4;
 								sysRam.Data_in<= Addr2(ADRLEN-1 downto Word) ; -- destination haut
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
 								dcount:=dcount+1;
+								end if;
 							elsif dcount=9 then
+								if interf.ramsel='0' then
 								adresse:=core_put_adr+5;
 								sysRam.Data_in<=Addr2(Word-1 downto 0); -- destination bas
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
 								dcount:=dcount+1;
+								end if;
 							elsif dcount=10 then
+								
 								SysRam.we<='1';
 								SysRam.ena<='1';
 								SysRam.enb<='1';
+								if interf.ramsel='0' then
 								adresse:=core_base_adr+1;
 								SysRam.addr_rd<=std_logic_vector(to_unsigned(core_base_adr+1,ADRLEN));
@@ -127,4 +142,5 @@
 								Interf.Instr_En<='1'; --active la prise en compte de l'instruction
 								dcount:=dcount+1;
+								end if;
 							elsif dcount=11 then
 								if Interf.Instr_ack='1' then -- le Core a reçu l'instruction ?
@@ -146,7 +162,9 @@
 									SysRam.ena<='1';  -- préparer l'écriture du résultat du Put
 									SysRam.enb<='1';
+									if interf.ramsel='0' then
 									config_reg:=SysRam.data_out and x"f6";
 									SysRam.Data_in<=config_reg ; --ramener le IPulse à 0;
 									dcount:=dcount+1;
+									end if;
 									SysRam.addr_rd<=std_logic_vector(to_unsigned(core_base_adr+1,ADRLEN));
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
@@ -183,5 +201,5 @@
   Target_Rank : natural; Target_disp : std_logic_vector; Target_Count : natural;
   Target_Datatype :natural; Win : natural) is
-variable i,dcount : natural:=0;
+variable i,wcount,dcount : natural range 0 to 255:=0;
 variable adresse :natural;
 variable addr1 :std_logic_vector(Orig_Addr'length-1 downto 0):=Orig_Addr;
@@ -201,12 +219,17 @@
 					
 				if rising_edge(clkin) then		
-							if dcount>=0 and dcount <=3 then 
+							
+						if dcount =0 then	
+							dcount:=dcount+1;
+						elsif dcount>=1 and dcount <=3 then 
 									if interf.ramsel='0' then
 											SysRam.we<='1';
 											SysRam.ena<='1';
 											SysRam.enb<='0';
-											WritePtr (get_adr,dcount,SysRam);
-											if dcount =4 then 
-												-- fin de l'écriture du pointeur en mémoire 
+											wcount:=interf.intstate1;
+											WritePtr (get_adr,wcount,SysRam);
+											interf.intstate1<=wcount;
+											if wcount =0 then 
+												dcount:=4;
 											end if;								
 									end if;
@@ -220,8 +243,9 @@
 								sysRam.Data_in<=MPI_GET & std_logic_vector(to_unsigned(Target_Rank,4)); --code fonction
 								sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
+								
 								dcount:=dcount+1;
 							end if;
 							elsif dcount=5 then 
-								if Interf.RamSel='0' then 
+								if Interf.RamSel='0' then	 
 									SysRam.we<='1';
 									SysRam.ena<='1';
@@ -229,4 +253,5 @@
 									sysRam.Data_in<=std_logic_vector(to_unsigned(Orig_Count,8)) ;--la longueur
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
+								
 									dcount:=dcount+1;
 								end if; 
@@ -238,5 +263,8 @@
 									sysRam.Data_in<= Addr1(ADRLEN-1 downto Word) ; --source Haut
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
-									dcount:=dcount+1;
+									
+									dcount:=dcount+1;
+								else
+									dcount:=dcount-1;
 								end if;
 							elsif dcount=7 then
@@ -247,5 +275,8 @@
 									sysRam.Data_in<=Addr1(Word-1 downto 0);  --source Bas
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
-									dcount:=dcount+1;
+									
+									dcount:=dcount+1;
+								else
+									dcount:=dcount-1;
 								end if;
 							elsif dcount=8 then
@@ -256,8 +287,11 @@
 									sysRam.Data_in<= Addr2(ADRLEN-1 downto Word) ; -- destination haut
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
-									dcount:=dcount+1;
+								
+									dcount:=dcount+1;
+								else
+									dcount:=dcount-1;
 								end if;
 							elsif dcount=9 then
-								if Interf.RamSel='0' then 
+								if Interf.RamSel='0' then
 									SysRam.we<='1';
 									SysRam.ena<='1';
@@ -265,8 +299,9 @@
 									sysRam.Data_in<=Addr2(Word-1 downto 0); -- destination bas
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
+								 
 									dcount:=dcount+1;
 								end if;
 							elsif dcount=10 then
-								if Interf.RamSel='0' then 
+								 
 									SysRam.we<='1';
 									SysRam.ena<='1';
@@ -277,4 +312,5 @@
 									sysRam.Data_in<=x"01"; --instruction pulse enable via la mémoire;
 									Interf.Instr_En<='1'; --active la prise en compte de l'instruction
+								if Interf.RamSel='0' then
 									dcount:=dcount+1;
 								end if;
@@ -294,25 +330,29 @@
 									SysRam.enb<='1';						
 							elsif dcount=12 then
-								if Interf.RamSel='0' then 
+								
 									adresse:=core_base_adr+1;
 									SysRam.we<='1';
 									SysRam.ena<='1';  -- préparer l'écriture du résultat du get
 									SysRam.enb<='1';
+								if Interf.RamSel='0' then 	
 									config_reg:=SysRam.data_out and x"f6";
 									SysRam.Data_in<=config_reg ; --ramener le IPulse à 0;
 									dcount:=dcount+1;
+								end if;
 									SysRam.addr_rd<=std_logic_vector(to_unsigned(core_base_adr+1,ADRLEN));
 									sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
-								end if;
+								
 							elsif dcount=13 then
-									if Interf.RamSel='0' then 
+									 
 										SysRam.we<='1';
 										SysRam.ena<='1';  -- préparer l'écriture du résultat du GET
 										SysRam.enb<='0';
+										adresse:=core_base_adr+1;
+										sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
+									if Interf.RamSel='0' then
 										config_reg:=SysRam.data_out and x"f6";
 										SysRam.Data_in<=config_reg ; --ramener le IPulse à 0;
 										dcount:=dcount+1;
-										adresse:=core_base_adr+1;
-										sysRam.Addr_wr<=Std_logic_vector(to_unsigned(adresse,ADRLEN));
+										
 									end if;
 							elsif dcount=14 then	
@@ -332,5 +372,5 @@
 							
 						  NExtCtx:=dcount;
-				end if;
+			end if; 
 	end procedure; 
 Procedure pMPI_Comm_group(NextCtx : inout natural;signal Interf:inout Core_io;signal SysRam : inout typ_dpram; COMM :in MPI_Comm; signal grp : out Mpi_group ) is 
@@ -361,7 +401,7 @@
 			adresse_rd:=CORE_INIT_ADR+1;
 			sysRam.Addr_rd<=Std_logic_vector(to_unsigned(adresse_rd,ADRLEN));
-			if Interf.Ramsel='0' then
+			
 				NextCtx:=1;
-			end if;
+		
 		elsif NextCtx=1 then
 			SysRam.we<='0';
@@ -600,5 +640,28 @@
  procedure pMPI_Win_wait( NextCtx : inout natural;signal Interf:inout Core_io;signal SysRam :inout typ_dpram; Win :MPI_Win) is
 --permet de synchroniser la fin des opérations sur une fenêtre
+variable dcount : natural range 0 to 255:=0;
+variable cstatus : std_logic_vector(Word-1 downto 0);
+
 begin
+
+	
+	
+		if NextCtx =0 then 
+			NextCtx:=NextCtx+1;
+		elsif NextCtx=1 then
+			if interf.ramsel='0' then
+					SysRam.we<='0';
+					SysRam.ena<='0';
+					SysRam.enb<='1';
+					SysRam.addr_rd<=Std_logic_vector(to_unsigned(core_base_adr+4,Adrlen));
+							if SysRam.Data_out(5)='1' and  SysRam.Data_out(4)='1' and SysRam.Data_out(2)='0' then 
+									NextCtx:=NextCtx+1;
+							end if;							
+			end if;
+	
+	elsif NextCtx=2 then
+		NextCtx:=0;
+	end if;
+
 
 end procedure;
Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MultiTest.wcfg
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MultiTest.wcfg	(revision 37)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MultiTest.wcfg	(revision 39)
@@ -14,8 +14,9 @@
             <top_module name="std_logic_arith" />
             <top_module name="std_logic_unsigned" />
+            <top_module name="textio" />
          </top_modules>
       </db_ref>
    </db_ref_list>
-   <WVObjectSize size="73" />
+   <WVObjectSize size="75" />
    <wvobject fp_name="/multimpitest/reset" type="logic" db_ref_id="1">
       <obj_property name="ElementShortName">reset</obj_property>
@@ -199,4 +200,12 @@
       <obj_property name="ElementShortName">ex1_state_mach</obj_property>
       <obj_property name="ObjectShortName">ex1_state_mach</obj_property>
+   </wvobject>
+   <wvobject fp_name="/multimpitest/uut/\connect_core(2)\/hardmpi/MPI_CORE_EX1_FSM/fifo_empty" type="logic" db_ref_id="1">
+      <obj_property name="ElementShortName">fifo_empty</obj_property>
+      <obj_property name="ObjectShortName">fifo_empty</obj_property>
+   </wvobject>
+   <wvobject fp_name="/multimpitest/uut/\connect_core(1)\/hardmpi/MPI_CORE_EX1_FSM/fifo_data_out" type="array" db_ref_id="1">
+      <obj_property name="ElementShortName">fifo_data_out[7:0]</obj_property>
+      <obj_property name="ObjectShortName">fifo_data_out[7:0]</obj_property>
    </wvobject>
    <wvobject fp_name="/multimpitest/uut/\connect_core(1)\/hardmpi/MPI_CORE_EX2_FSM/ex2_state_mach" type="other" db_ref_id="1">
